<template>
  <div class="quick-search inline-block">
    <i-input v-model="searchValue" @keyup.enter.native="onSearchAction">
      <i-select class="search-column" slot="prepend"
                v-model="searchColumn" :placeholder="placeholder"
                :style="{width: fieldDropdownWidth}">
        <i-option v-for="(option, index) in fields" :key="index" :value="option.value">
          {{option.label}}
        </i-option>
      </i-select>
      <Button icon="ios-search" slot="append" @click.native="onSearchAction"></Button>
    </i-input>
  </div>
</template>

<script>

  const actions = {
    onSearchAction() {
      this.onSearchEmit();
    }
  };

  const emits = {
    onSearchEmit() {
      this.$emit('on-search', {
        searchColumn: this.searchColumn,
        searchValue: this.searchValue,
      });
    },
  };

  export default {
    name: 'StockQuickSearch',
    props: {
      fields: { type: Array, required: true },
      defaultField: { required: true },
      placeholder: { type: String, default: undefined },
      fieldDropdownWidth: { type: String, default: '120px' },
    },
    data() {
      return {
        searchValue: undefined,
        searchColumn: this.defaultField,
      };
    },
    methods: {
      ...emits,
      ...actions,
    },
  }
</script>

<style lang="scss" scoped>
  .quick-search {
    float: right;
    padding: 15px 0;
    .search-column {
      width: 120px;
    }
  }
</style>
